'==================================================================='
' MPORT1.BAS - A PROGRAM TO CONTROL PARALLEL PORT OUTPUT LINES       '
'==================================================================='

S$="      |  0  |  0  |  0  |  0  |  0  |  0  |  0  |  0  |"
S1$="--> Port Status"
'--------------------------------------------------------------------'
' TURN OFF ALL THE PORT LINES                                        '
'--------------------------------------------------------------------'

OUT &H378,0			'Turn off all Port Lines

C%=0				'Set up the Port Output Value

10 cls				'Clear the screen and dsiplay the Title
PRINT"==============================================================================="
print
print"                           JEFFREY'S CONTROL PROGRAM"
PRINT
PRINT"                              BY Jeffrey Genovy"
PRINT
PRINT"                                  Version 1.00"
PRINT"==============================================================================="
'
'Display the Port Data Line status on the screen. 0 = off 1 = on
'
PRINT
PRINT"      +-----+-----+-----+-----+-----+-----+-----+-----+"
PRINT"      |  1  |  2  |  3  |  4  |  5  |  6  |  7  |  8  | --> Port Data Lines"
PRINT"      +-----+-----+-----+-----+-----+-----+-----+-----+"
PRINT S$,s1$
'PRINT"      |  0  |  0  |  0  |  0  |  0  |  0  |  0  |  0  |"
PRINT"      +-----+-----+-----+-----+-----+-----+-----+-----+     0 = OFF 1 = ON"
PRINT
INPUT "Enter the Port Line to change (Q to quit,C to clear all lines) ",A$
IF A$="Q" GOTO 50     		'Check if the User wants to quit
IF A$="q" GOTO 50
IF A$="C" GOTO 40
PRINT
INPUT "Enter 1 to turn ON, 2 to turn OFF",B$
PRINT
IF VAL(A$) >8 GOTO 10           'Make sure Port Line in correct range
IF VAL(A$) <1 GOTO 10
IF B$="1" GOTO 20               'Check for ON or OFF function
IF B$="2" GOTO 30
GOTO 10                         'Loop back to start

'--------------------------------------------------------------------'
' TURN ON THE PORT LINE                                              '
' OR the new output with previous output value and also update the   '
' S$ string used to display the Port Line status on the screen       '
'--------------------------------------------------------------------'

20 IF A$="1" THEN		'OR outputs to create new value
   OUT &H378,(1 OR C%)		'Output to Port
   C%=C% OR 1			'Update the previous value
   MID$(S$,10)="1"              'Update the S$ display string
ELSEIF A$="2" THEN              'Port Line 2
   OUT &H378,(2 OR C%)          'Output to Port
   C%=C% OR 2                   'Update the previous value
   MID$(S$,16)="1"              'Update the S$ display string
ELSEIF A$="3" THEN              'Port Line 3
   OUT &H378,(4 OR C%)
   C%=C% OR 4
   MID$(S$,22)="1"
ELSEIF A$="4" THEN              'Port Line 4
   OUT &H378,(8 OR C%)
   C%=C% OR 8
   MID$(S$,28)="1"
ELSEIF A$="5" THEN		'Port Line 5	
   OUT &H378,(16 OR C%)
   C%=C% OR 16
   MID$(S$,34)="1"
ELSEIF A$="6" THEN              'Port Line 6
   OUT &H378,(32 OR C%)
   C%=C% OR 32
   MID$(S$,40)="1"
ELSEIF A$="7" THEN              'Port Line 7
   OUT &H378,(64 OR C%)
   C%=C% OR 64
   MID$(S$,46)="1"
ELSEIF A$="8" THEN              'Port Line 8
   OUT &H378,(128 OR C%)
   C%=C% OR 128
   MID$(S$,52)="1"
END IF

GOTO 10				'Loop back to start

'--------------------------------------------------------------------'
' TURN OFF THE PORT LINE                                             '
' AND the new output with previous output value and also update the  '
' S$ string used to display the Port Line status on the screen       '
'--------------------------------------------------------------------'

30 IF A$="1" THEN               'AND outputs to create new value
   OUT &H378,(254 AND C%)       'Output to Port
   C%=C% AND 254                'Update the previous value
   MID$(S$,10)="0"              'Update the S$ display string
ELSEIF A$="2" THEN              'Port Line 2
   OUT &H378,(253 AND C%)
   C%=C% AND 253
   MID$(S$,16)="0"
ELSEIF A$="3" THEN              'Port Line 3
   OUT &H378,(251 AND C%)
   C%=C% AND 251
   MID$(S$,22)="0"
ELSEIF A$="4" THEN              'Port Line 4
   OUT &H378,(247 AND C%)
   C%=C% AND 247
   MID$(S$,28)="0"
ELSEIF A$="5" THEN              'Port Line 5
   OUT &H378,(239 AND C%)
   C%=C% AND 239
   MID$(S$,34)="0"
ELSEIF A$="6" THEN              'Port Line 6
   OUT &H378,(223 AND C%)
   C%=C% AND 223
   MID$(S$,40)="0"
ELSEIF A$="7" THEN              'Port Line 7
   OUT &H378,(64 AND C%)
   C%=C% AND 64
   MID$(S$,46)="0"
ELSEIF A$="8" THEN              'Port Line 8
   OUT &H378,(127 AND C%)
   C%=C% AND 127
   MID$(S$,52)="0"
END IF

GOTO 10				'Loop back to start

'--------------------------------------------------------------------'
' TURN OFF ALL THE PORT LINES                                        '
'--------------------------------------------------------------------'

40 OUT &H378,0			'Turn off all Port Lines
C% = 0
GOTO 10				'Loop back to start

50 OUT &H378,0			'Turn off all Port Lines before quiting

END

STOP










